unit options;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, IniFiles, ExtCtrls;

type
  TfmOptions = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    cbShowToolBar: TCheckBox;
    btnCancel: TBitBtn;
    btnOK: TBitBtn;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    GroupBox1: TGroupBox;
    lblU3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblU1: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    lblU2: TPanel;
    Label6: TLabel;
    btnAcqTest: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnAcqTestClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    procedure ReadUserPrefs;
    procedure SaveUserPrefs;
    procedure RunAcqTest;
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fmOptions: TfmOptions;

implementation

uses
  rmMisc, main;

{$R *.DFM}

procedure TfmOptions.FormCreate(Sender: TObject);
begin
  PageControl1.ActivePage := TabSheet1;
end;

procedure TfmOptions.FormActivate(Sender: TObject);
begin
  ReadUserPrefs;
end;

procedure TfmOptions.btnOKClick(Sender: TObject);
begin
  SaveUserPrefs;
end;

procedure TfmOptions.ReadUserPrefs;
var
  ini: TIniFile;
begin
  ini := TIniFile.Create(IniFileName);
  try

  finally
    ini.Free;
  end;

end;

procedure TfmOptions.SaveUserPrefs;
var
  ini: TIniFile;
begin

end;



procedure TfmOptions.btnAcqTestClick(Sender: TObject);
begin
  if btnAcqTest.Down then
    btnAcqTest.Caption := 'Stopper le test'
  else
    btnAcqTest.Caption := 'Dmarrer le test';
  RunAcqTest;
end;

procedure TfmOptions.RunAcqTest;
var
  i, j, temp: integer;
  addr: string[4];
  val: integer;
  EOC: boolean;
  timeOut: integer;
  t: longInt;
begin
  timeOut := 20;

  repeat

    for i := 0 to 13 do begin

      // adresse de l'entre  lire
      addr := byteToBits(i, 4);

      // rcupration des valeurs chantillonnes par le TLC1543
      temp := 1024;
      val := 0;
      for j := 1 to 10 do begin
        temp := temp div 2;
        if j < 5 then
          fmMain.WriteAddr(copy(Addr, j, 1) = '1')                 // via RTS
        else
          fmMain.WriteAddr(false);                                 // via RTS
        fmMain.WriteCLK(true);  // front montant de l'horloge      // via DTR
        if fmMain.ReadDataBit then val := val + temp;              // via CTS
        fmMain.WriteCLK(false); // front descendant de l'horloge   // via DTR
      end;

      t := GetTickCount;
      repeat
         EOC := fmMain.ReadEOC;                                      // via DSR
      until EOC or (GetTickCount > (t + timeOut));

      // affichage des valeurs
      case i of
        12 : lblU1.Caption := intToStr(val);
        13 : lblU2.Caption := intToStr(val);
        0 : lblU3.Caption := intToStr(val);
      end;
    end;
    delay(100, true);

  until (not btnAcqTest.Down);
end;


procedure TfmOptions.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  OKForClose: boolean;
begin
  OKForClose := not btnAcqTest.Down;
  if not OKForClose then begin
    canClose := false;
    ShowMessage('Test en cours !');
  end else begin
    canClose := true;
  end;
end;

end.
